//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "DirectoryViewer.h"
//---------------------------------------------------------------------------
static inline TDirectoryViewer *ValidCtrCheck ()
{
	return new TDirectoryViewer (NULL);
}
//---------------------------------------------------------------------------
__fastcall TDirectoryViewer::TDirectoryViewer (TComponent* Owner) : TCustomListView (Owner)
{
	char directorio_windows [512];
    DWORD handle;
    SHFILEINFO informacion;
	LlamarHeredado = false;
	GetWindowsDirectory (directorio_windows, 512);
    SHGetFileInfo (directorio_windows, 0, & InformacionDirectorios, sizeof (SHFILEINFO), SHGFI_DISPLAYNAME | SHGFI_TYPENAME | SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
    handle = SHGetFileInfo ("", 0, & informacion, sizeof (SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_LARGEICON);
    ListaIconosGrandes = new TImageList (this);
    ListaIconosGrandes -> Handle = handle;
    ListaIconosGrandes -> ShareImages = true;
    LargeImages = ListaIconosGrandes;
    handle = SHGetFileInfo ("", 0, & informacion, sizeof (SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
    ListaIconosMini = new TImageList (this);
    ListaIconosMini -> Handle = handle;
    ListaIconosMini -> ShareImages = true;
    SmallImages = ListaIconosMini;
    FDirectorioActual = "\\";
    FMascaraNombreArchivo = "*";
    FMascaraExtensionArchivo = "*";
    FTotalNumberOfFiles = 0;
    FTotalNumberOfFilesDisplayed = 0;
    FExploracionAutomatica = true;
    FOpciones = TOpcionesDirectoryViewer () << dvVerSubDirectorios << dvVerArchivos;
    FColumnas = TInformacionFicherosDirectoryViewer ();
    OnCompare = CompararItems;
    FOnDblClick = NULL;
    FOnDirectoryChange = NULL;
    FOnDirectoryChanging = NULL;
    FOnDisplayChange = NULL;
    FOnKeyPress = NULL;
    IdentificadorDirectorioPadre = "..";
    IdentificadorDirectorioActual = ".";
    TCustomListView::ViewStyle = FEstiloVisible = vsIcon;
    SortType = stText;
    ParametrosOrdenacion.IdColumna = ifVerTodas;
    ShowColumnHeaders = true;
    FFastLoad = true;
}
//---------------------------------------------------------------------------
__fastcall TDirectoryViewer::~TDirectoryViewer (void)
{
	if ((Parent) && (Visible))
    	Hide ();
    delete ListaIconosGrandes;
    delete ListaIconosMini;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::ProcesarCNNotify (TMessage & mensaje)
{
	if (((LPNMHDR) mensaje.LParam) -> code == LVN_GETDISPINFO) {
    	TLVItem * info_item = & ((PLVDispInfo) mensaje.LParam) -> item;
	   	TListItem * item = Items -> Item [info_item -> iItem];
        if (info_item -> mask & LVIF_TEXT) {
	   		if (! info_item -> iSubItem)
    	   		strcpy (info_item -> pszText, item -> Caption.SubString (1, info_item -> cchTextMax).c_str ());
        	else if (info_item -> iSubItem <= item -> SubItems -> Count)
        		strcpy (info_item -> pszText, item -> SubItems -> Strings [info_item -> iSubItem - 1].SubString (1, info_item -> cchTextMax).c_str ());
	 		else
    	   	    info_item -> pszText [0] = '\0';
        }
		if (info_item -> mask & LVIF_IMAGE) {
	    	if ((info_item -> iImage = item -> ImageIndex) == -1) {
            	SHFILEINFO informacion;
                DWORD longitud_icono = (FEstiloVisible == vsIcon) ? SHGFI_LARGEICON : SHGFI_SMALLICON;
	            strcpy (& Path [FDirectorioActual.Length ()], item -> Caption.c_str ());
        	    if (SHGetFileInfo (Path, 0, & informacion, sizeof (SHFILEINFO), SHGFI_ICON | SHGFI_SYSICONINDEX | longitud_icono))
	   		        info_item -> iImage = item -> ImageIndex = informacion.iIcon;
       		}
        }
	    mensaje.Result = true;
    }
    else
    	TCustomListView::WndProc (mensaje);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::WndProc (Messages::TMessage & Message)
{
	if ((Message.Msg == CN_NOTIFY) && (! LlamarHeredado)) {
       	LlamarHeredado = true;
        ProcesarCNNotify (Message);
        LlamarHeredado = false;
    }
	else
    	TCustomListView::WndProc (Message);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::DblClick (void)
{
	if (Selected) {
    	if (! FExploracionAutomatica) {
        	if (FOnDblClick)
            	FOnDblClick (this);
        }
        else {
        	if (((DWORD) Selected -> Data) & FILE_ATTRIBUTE_DIRECTORY) {
            	if (Selected -> Caption == "..") {
                	int posicion = 0;
                    for (int i = 1; i < FDirectorioActual.Length (); i ++)
                    	if (FDirectorioActual [i] == '\\')
                        	posicion = i;
                    if (posicion)
	                    DirectorioActual = FDirectorioActual.SubString (1, posicion);
                }
                else
            		DirectorioActual = FDirectorioActual + Selected -> Caption;
            }
            else
            	if (FOnDblClick)
                	FOnDblClick (this);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::KeyPress (char & tecla)
{
	if (tecla == VK_RETURN) {
    	DblClick ();
        tecla = 0;
    }
    else if (FOnKeyPress)
    	FOnKeyPress (this, tecla);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::InsertarArchivo (const WIN32_FIND_DATA & atributos)
{
	try {
    	TListItem * item;
        if (! FOpciones.Contains (dvVerTodo)) {
			if ((! FOpciones.Contains (dvVerPadre)) && (IdentificadorDirectorioPadre == atributos.cFileName))
    			return;
        	if ((! FOpciones.Contains (dvVerDirectorioActual)) && (IdentificadorDirectorioActual == atributos.cFileName))
        		return;
        	if ((! FOpciones.Contains (dvVerSubDirectorios)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
        		return;
	        if ((! FOpciones.Contains (dvVerArchivos)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE))
    	    	return;
        	if ((! FOpciones.Contains (dvVerArchivosOcultos)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN))
        		return;
	        if ((! FOpciones.Contains (dvVerArchivosSistema)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM))
    	    	return;
        	if ((! FOpciones.Contains (dvVerArchivosSoloLectura)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_READONLY))
        		return;
        	if ((! FOpciones.Contains (dvVerArchivosTemporales)) && (atributos.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY))
        		return;
        }
	    (item = Items -> Add ()) -> Caption = atributos.cFileName;
		FTotalNumberOfFilesDisplayed ++;
        item -> Data = (TObject *) atributos.dwFileAttributes;
       	if (! (atributos.dwFileAttributes ^ FILE_ATTRIBUTE_DIRECTORY))
           	item -> ImageIndex = InformacionDirectorios.iIcon;
        else {
        	if (FFastLoad)
            	item -> ImageIndex = -1;
            else {
	       	    SHFILEINFO informacion;
                DWORD longitud_icono = (FEstiloVisible == vsIcon) ? SHGFI_LARGEICON : SHGFI_SMALLICON;
    	        strcpy (& Path [FDirectorioActual.Length ()], item -> Caption.c_str ());
       		    if (SHGetFileInfo (Path, 0, & informacion, sizeof (SHFILEINFO), SHGFI_ICON | SHGFI_SYSICONINDEX | longitud_icono))
		        	item -> ImageIndex = informacion.iIcon;
            }
        }
        if (FEstiloVisible == vsReport) {
            for (int i = 0; i < Columns -> Count; i ++)
            	item -> SubItems -> Add (" ");
        	if ((! (atributos.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) && ((FColumnas.Contains (ifLongitud)) || (FColumnas.Contains (ifVerTodas)))) {
            	double bytes = (atributos.nFileSizeHigh * MAXDWORD) + atributos.nFileSizeLow;
            	if (bytes < 1024)
            		item -> SubItems -> Strings [PunterosColumnas [ifLongitud]] = AnsiString (bytes) + " Bytes";
                else if (bytes < 1024L * 1024L)
            		item -> SubItems -> Strings [PunterosColumnas [ifLongitud]] = AnsiString (bytes / 1024) + " KBytes";
                else
            		item -> SubItems -> Strings [PunterosColumnas [ifLongitud]] = AnsiString (bytes / (1024L * 1024L)) + " MBytes";
            }
            if ((FColumnas.Contains (ifTipo)) || (FColumnas.Contains (ifVerTodas))) {
            	if (atributos.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
	        		item -> SubItems -> Strings [PunterosColumnas [ifTipo]] = InformacionDirectorios.szTypeName;
            	else {
				    SHFILEINFO informacion;
	    	        strcpy (& Path [FDirectorioActual.Length ()], item -> Caption.c_str ());
				    SHGetFileInfo (Path, 0, & informacion, sizeof (SHFILEINFO), SHGFI_DISPLAYNAME | SHGFI_TYPENAME);
				    item -> SubItems -> Strings [PunterosColumnas [ifTipo]] = informacion.szTypeName;
                }
            }
            if ((FColumnas.Contains (ifModificado)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifModificado]] = ObtenerStringFechaArchivo (atributos.ftLastWriteTime);
            if ((FColumnas.Contains (ifCreacion)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifCreacion]] = ObtenerStringFechaArchivo (atributos.ftCreationTime);
            if ((FColumnas.Contains (ifUltimoAcceso)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifUltimoAcceso]] = ObtenerStringFechaArchivo (atributos.ftLastAccessTime);
            if ((FColumnas.Contains (ifAtributos)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifAtributos]] = ObtenerStringAtributos (atributos.dwFileAttributes);
            if ((FColumnas.Contains (ifNombreDos)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifNombreDos]] = (strlen (atributos.cAlternateFileName) == 0) ? atributos.cFileName : atributos.cAlternateFileName;
            if ((FColumnas.Contains (ifExtensionDos)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifExtensionDos]] = ObtenerExtensionArchivo ((strlen (atributos.cAlternateFileName) == 0) ? (char *) atributos.cFileName : (char *) atributos.cAlternateFileName, false);
            if ((FColumnas.Contains (ifRuta)) || (FColumnas.Contains (ifVerTodas)))
        		item -> SubItems -> Strings [PunterosColumnas [ifRuta]] = FDirectorioActual + atributos.cAlternateFileName;
        }
    }
    catch (...) {
    }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDirectoryViewer::ObtenerStringFechaArchivo (const FILETIME & fecha)
{
	SYSTEMTIME fecha_sistema;
    FileTimeToSystemTime (& fecha, & fecha_sistema);
    return AnsiString ((int) fecha_sistema.wDay) + "/" + AnsiString ((int) fecha_sistema.wMonth) + "/" + AnsiString ((int) fecha_sistema.wYear) + " " + AnsiString ((int) fecha_sistema.wHour) + ":" + AnsiString ((int) fecha_sistema.wMinute);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDirectoryViewer::ObtenerStringAtributos (DWORD atributos)
{
	AnsiString resultado = "";
    if (atributos & FILE_ATTRIBUTE_DIRECTORY)
    	resultado = resultado + "D";
    if (atributos & FILE_ATTRIBUTE_ARCHIVE)
    	resultado = resultado + "A";
    if (atributos & FILE_ATTRIBUTE_READONLY)
    	resultado = resultado + "R";
    if (atributos & FILE_ATTRIBUTE_SYSTEM)
    	resultado = resultado + "S";
    if (atributos & FILE_ATTRIBUTE_HIDDEN)
    	resultado = resultado + "H";
    if (atributos & FILE_ATTRIBUTE_COMPRESSED)
    	resultado = resultado + "C";
    if (atributos & FILE_ATTRIBUTE_TEMPORARY)
    	resultado = resultado + "T";
    return resultado;
}
//---------------------------------------------------------------------------
int __fastcall TDirectoryViewer::OrdenarColumna (TListItem * i1, TListItem * i2)
{
	int resultado = 0;
	if ((((DWORD) i1 -> Data) & FILE_ATTRIBUTE_DIRECTORY) && (! (((DWORD) i2 -> Data) & FILE_ATTRIBUTE_DIRECTORY)))
    	resultado = -1;
    else if (! ((((DWORD) i1 -> Data) & FILE_ATTRIBUTE_DIRECTORY)) && (((DWORD) i2 -> Data) & FILE_ATTRIBUTE_DIRECTORY))
    	resultado = 1;
    else {
    	if (ParametrosOrdenacion.IdColumna == ifVerTodas) {
		    if (i1 -> Caption.UpperCase () < i2 -> Caption.UpperCase ())
				resultado = -1;
	    	else if (i1 -> Caption.UpperCase () > i2 -> Caption.UpperCase ())
				resultado = 1;
        }
        else {
		    if (i1 -> SubItems -> Strings [ParametrosOrdenacion.IdColumna].UpperCase () < i2 -> SubItems -> Strings [ParametrosOrdenacion.IdColumna].UpperCase ())
				resultado = -1;
	    	else if (i1 -> SubItems -> Strings [ParametrosOrdenacion.IdColumna].UpperCase () > i2 -> SubItems -> Strings [ParametrosOrdenacion.IdColumna].UpperCase ())
				resultado = 1;
        }
    }
    if (! ParametrosOrdenacion.Alfabetica)
    	resultado *= -1;
    return resultado;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::CompararItems (TObject * yo, TListItem * i1, TListItem * i2, int datos, int & resultado)
{
	ParametrosOrdenacion.Alfabetica = true;
    ParametrosOrdenacion.IdColumna = ifVerTodas;
	resultado = OrdenarColumna (i1, i2);
}
//---------------------------------------------------------------------------
int __stdcall OrdenarColumnaDirectoryViewer (int i1, int i2, int p)
{
	return ((TDirectoryViewer *) p) -> OrdenarColumna ((TListItem *) i1, (TListItem *) i2);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::ColClick (TListColumn * columna)
{
	if ((! FColumnas.Contains ((TInformacionFicheroDirectoryViewer) columna -> Index)) || (columna -> Index == ifVerTodas))
    	return;
	if (columna -> Index == ParametrosOrdenacion.IdColumna)
    	ParametrosOrdenacion.Alfabetica = ! ParametrosOrdenacion.Alfabetica;
    else {
    	ParametrosOrdenacion.IdColumna = (TInformacionFicheroDirectoryViewer) columna -> Index;
    	ParametrosOrdenacion.Alfabetica = true;
    }
	CustomSort (OrdenarColumnaDirectoryViewer, (long) this);
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::ObtenerDirectorioActual (void)
{
   	WIN32_FIND_DATA estructura_informacion;
    HANDLE handle;
    AnsiString temporal = FDirectorioActual + "*";
    FTotalNumberOfFiles = 0;
    FTotalNumberOfFilesDisplayed = 0;
	Items -> BeginUpdate ();
    Items -> Clear ();
    TCustomListView::ViewStyle = vsIcon;
    TSortType tipo_ordenacion = SortType;
    SortType = stNone;
	Screen -> Cursor = crHourGlass;
	try {
	    if ((handle = FindFirstFile (temporal.c_str (), & estructura_informacion)) != INVALID_HANDLE_VALUE) {
		    do {
        	    if ((estructura_informacion.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && ((FOpciones.Contains (dvVerSubDirectorios)) || (FOpciones.Contains (dvVerTodo))))
					InsertarArchivo (estructura_informacion);
	        	else if (ArchivoCumpleMascara (estructura_informacion.cFileName))
		           	InsertarArchivo (estructura_informacion);
	    	    Application -> ProcessMessages ();
			    FTotalNumberOfFiles ++;
	        } while (FindNextFile (handle, & estructura_informacion));
    	    FindClose (handle);
        }
    }
    catch (...) {
    }
    SortType = tipo_ordenacion;
    TCustomListView::ViewStyle = FEstiloVisible;
	Items -> EndUpdate ();
	Screen -> Cursor = crDefault;
    if (FOnDisplayChange)
    	FOnDisplayChange (this);
}
//---------------------------------------------------------------------------
char * __fastcall TDirectoryViewer::ObtenerExtensionArchivo (char * archivo, bool separar)
{
	int posicion_separador = DondeEmpiezaExtensionArchivo (archivo);
    if (posicion_separador == -1)
    	return NULL;
    else {
    	if (separar)
	    	archivo [posicion_separador] = 0;
        return & archivo [posicion_separador + 1];
    }
}
//---------------------------------------------------------------------------
int __fastcall TDirectoryViewer::DondeEmpiezaExtensionArchivo (char * archivo)
{
	int i = 0, posicion_separador = -1;
    while (archivo [i]) {
    	if (archivo [i] == '.')
        	posicion_separador = i;
    	i ++;
    }
	return posicion_separador;
}
//---------------------------------------------------------------------------
bool __fastcall TDirectoryViewer::ArrayCumpleMascara (char * texto, char * mascara)
{
	int indice_texto = 0, indice_mascara = 0, i;
    if (! mascara [0])
    	return true;
    while ((mascara [indice_mascara]) && (texto [indice_texto])) {
    	switch (mascara [indice_mascara]) {
        	case '*' :
            	i = 0;
                if (! mascara [indice_mascara + 1])
                	return true;
                while (texto [indice_texto + i]) {
                	if (ArrayCumpleMascara (& texto [indice_texto + i], & mascara [indice_texto + 1]))
						return true;
                    i ++;
                }
                return false;
            case '+' :
            	i = 1;
                if (! texto [indice_texto + 1]) {
                	i = 1;
                    while (mascara [indice_mascara + i]) {
                    	if (mascara [indice_mascara + i] != '*')
                        	return false;
                        i ++;
                    }
                    return true;
                }
                mascara [indice_mascara] = '*';
                while (texto [indice_texto + i]) {
                	if (ArrayCumpleMascara (& texto [indice_texto + i], & mascara [indice_mascara])) {
		                mascara [indice_mascara] = '+';
						return true;
                    }
                    i ++;
                }
                mascara [indice_mascara] = '+';
                return false;
            case '?' :
            	indice_mascara ++;
                indice_texto ++;
                break;
            default :
            	if ((mascara [indice_mascara] >= 'a') && (mascara [indice_mascara] <= 'z')) {
                	if ((texto [indice_texto] != mascara [indice_mascara]) && (texto [indice_texto] != mascara [indice_mascara] - 'a' + 'A'))
                    	return false;
                }
                else if (mascara [indice_mascara] != texto [indice_texto])
                	return false;
                indice_mascara ++;
                indice_texto ++;
            	break;
        }
    }
    if (texto [indice_texto])
    	return false;
    if (! mascara [indice_mascara])
    	return true;
    while (mascara [indice_mascara]) {
    	if (mascara [indice_mascara] != '*')
        	return false;
        indice_mascara ++;
    }
    return true;
}
//---------------------------------------------------------------------------
bool __fastcall TDirectoryViewer::ArchivoCumpleMascara (char * fichero)
{
    char * extension_fichero = ObtenerExtensionArchivo (fichero, true);
    bool resultado = true;
    if (resultado) {
        if ((resultado = ArrayCumpleMascara (fichero, FMascaraNombreArchivo.c_str ())) == true) {
        	if (extension_fichero)
            	resultado = ArrayCumpleMascara (extension_fichero, FMascaraExtensionArchivo.c_str ());
            else {
				for (int i = 1; i <= FMascaraExtensionArchivo.Length (); i ++)
                	if (FMascaraExtensionArchivo [i] != '*')
                    	resultado = false;
            }
        }
    }
    if (extension_fichero)
    	fichero [strlen (fichero)] = '.';
    return resultado;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::InicializarColumnas (void)
{
	int i = 0;
    TListColumn * columna;
	Columns -> Clear ();
    columna = Columns -> Add ();
   	columna -> Caption = "Nombre del archivo";
    columna -> Width = 160;
   	columna -> Alignment = taRightJustify;
	if ((FColumnas.Contains (ifLongitud)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Tamao";
	    columna -> Width = 60;
    	columna -> Alignment = taRightJustify;
        PunterosColumnas [ifLongitud] = i ++;
    }
	if ((FColumnas.Contains (ifTipo)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Tipo";
	    columna -> Width = 130;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifTipo] = i ++;
    }
	if ((FColumnas.Contains (ifModificado)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "ltima Modificacin";
	    columna -> Width = 100;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifModificado] = i ++;
    }
	if ((FColumnas.Contains (ifCreacion)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Fecha Creacin";
	    columna -> Width = 100;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifCreacion] = i ++;
    }
	if ((FColumnas.Contains (ifUltimoAcceso)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "ltimo Acceso";
	    columna -> Width = 85;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifUltimoAcceso] = i ++;
    }
	if ((FColumnas.Contains (ifAtributos)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Atributos";
	    columna -> Width = 60;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifAtributos] = i ++;
    }
	if ((FColumnas.Contains (ifNombreDos)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Nombre DOS";
	    columna -> Width = 130;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifNombreDos] = i ++;
    }
	if ((FColumnas.Contains (ifExtensionDos)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Extensin DOS";
	    columna -> Width = 60;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifExtensionDos] = i ++;
    }
	if ((FColumnas.Contains (ifRuta)) || (FColumnas.Contains (ifVerTodas))) {
	    columna = Columns -> Add ();
    	columna -> Caption = "Ruta";
	    columna -> Width = 200;
    	columna -> Alignment = taLeftJustify;
        PunterosColumnas [ifRuta] = i;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::AsignarDirectorioActual (AnsiString directorio)
{
	bool cambiar = true;
	if (directorio.IsEmpty ())
    	return;
    if (FOnDirectoryChanging) {
	    FOnDirectoryChanging (this, FDirectorioActual, directorio, cambiar);
	    if (! cambiar)
    		return;
    }
	if (directorio [directorio.Length ()] != '\\')
    	directorio = directorio + "\\";
	if (FDirectorioActual == directorio)
    	return;
    FDirectorioActual = directorio;
    strcpy (Path, FDirectorioActual.c_str ());
    if (FOnDirectoryChange)
    	FOnDirectoryChange (this);
    ObtenerDirectorioActual ();
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::AsignarMascara (AnsiString mascara)
{
	int posicion_separador = DondeEmpiezaExtensionArchivo (mascara.c_str ());
    if (posicion_separador == -1) {
    	FMascaraNombreArchivo = mascara;
		FMascaraExtensionArchivo = "*";
    }
    else {
    	FMascaraNombreArchivo = mascara.SubString (1, posicion_separador);
		FMascaraExtensionArchivo = mascara.SubString (posicion_separador + 2, mascara.Length () - posicion_separador - 1);
    }
	if (mascara.IsEmpty ())
    	FMascaraNombreArchivo = "*";
    ObtenerDirectorioActual ();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TDirectoryViewer::ObtenerMascara (void)
{
	return FMascaraNombreArchivo + "." + FMascaraExtensionArchivo;
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::AsignarOpciones (TOpcionesDirectoryViewer opciones)
{
	if (FOpciones == opciones)
    	return;
    FOpciones = opciones;
    ObtenerDirectorioActual ();
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::AsignarColumnas (TInformacionFicherosDirectoryViewer columnas)
{
	if (FColumnas == columnas)
    	return;
    FColumnas = columnas;
    if (FEstiloVisible == vsReport) {
    	InicializarColumnas ();
        ObtenerDirectorioActual ();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectoryViewer::AsignarEstiloVisible (TViewStyle estilo)
{
	bool recargar = ((estilo == vsReport) || (FEstiloVisible == vsReport));
	if (estilo == FEstiloVisible)
    	return;
    if (estilo == vsReport)
    	InicializarColumnas ();
    FEstiloVisible = estilo;
    if (recargar)
	    ObtenerDirectorioActual ();
    TCustomListView::ViewStyle = estilo;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
namespace Directoryviewer
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TDirectoryViewer)};
		RegisterComponents("Win95", classes, 0);
	}
}
//---------------------------------------------------------------------------
